<script>
import { MetisMenu } from 'metismenujs';
import config from "../config";
import { menuItems } from "./menu";
import NavBar from "./nav-bar";
import SiteLogo from "./site-logo";


export default {
  data() {
    return {
      config: config,
      menuItems: menuItems,
      visible: true
    };
  },
  components: { NavBar, SiteLogo },
  mounted: function () {
    // this.$data.menuItems[0].subItems[1].label = this.$auth.setting.driver_name;
    // eslint-disable-next-line no-unused-vars
    var menuRef = new MetisMenu("#side-menu");
    var links = document.getElementsByClassName("side-nav-link-ref");
    var matchingMenuItem = null;
    const paths = [];

    for (var i = 0; i < links.length; i++) {
      paths.push(links[i]["pathname"]);
    }
    var itemIndex = paths.indexOf(window.location.pathname);
    if (itemIndex === -1) {
      const strIndex = window.location.pathname.lastIndexOf("/");
      const item = window.location.pathname.substr(0, strIndex).toString();
      var x = paths.reduce((a, p) => (window.location.pathname.indexOf(p) !== -1 ? p : a), 0)
      matchingMenuItem = links[paths.indexOf(x)];
    } else {
      matchingMenuItem = links[itemIndex];
    }
    if (matchingMenuItem) {
      matchingMenuItem.classList.add("active");
      var parent = matchingMenuItem.parentElement;
      /**
       * TODO: This is hard coded way of expading/activating parent menu dropdown and working till level 3.
       * We should come up with non hard coded approach
       */
      if (parent) {
        parent.classList.add("mm-active");
        const parent2 = parent.parentElement.closest("ul");
        if (parent2 && parent2.id !== "side-menu") {
          parent2.classList.add("mm-show");
          // console.log("data",parent2.scrollHeight);
          parent2.scrollTop = parent2.scrollHeight + 120;
          // console.log("scrollTop",parent2.scrollTop);
          parent2.scrollIntoView(false);
          parent2.scrollIntoView({ behavior: "smooth", block: "end" });

          const parent3 = parent2.parentElement;
          if (parent3) {
            parent3.classList.add("mm-active");
            var childAnchor = parent3.querySelector(".has-arrow");
            var childDropdown = parent3.querySelector(".has-dropdown");
            if (childAnchor) childAnchor.classList.add("mm-active");
            if (childDropdown) childDropdown.classList.add("mm-active");

            const parent4 = parent3.parentElement;
            if (parent4 && parent4.id !== "side-menu") {
              parent4.classList.add("mm-show");
              const parent5 = parent4.parentElement;
              if (parent5 && parent5.id !== "side-menu") {
                parent5.classList.add("mm-active");
                const childanchor = parent5.querySelector(".is-parent");
                if (childanchor && parent5.id !== "side-menu") {
                  childanchor.classList.add("mm-active");
                }
              }
            }
          }
        }
      } else {
        matchingMenuItem.classList.add("mm-active");
      }
    }
  },
  methods: {
    /**
     * Returns true or false if given menu item has child or not
     * @param item menuItem
     */
    hasItems(item) {
      return item.subItems !== undefined ? item.subItems.length > 0 : false;
    },

    getBadge(badges) {
      return '';
    },

  },
};
</script>


<template>
  <!-- ========== Left Sidebar Start ========== -->
  <div>
    <!-- ========== Logo Start ========== -->
      <SiteLogo/>
      <!-- ========== Logo End ========== -->
    <!--- Sidemenu -->
    <div id="sidebar-menu">
      <!-- Left Menu Start -->
        <ul id="side-menu" class="metismenu list-unstyled">
          <template v-for="item in menuItems">
            <li
              class="menu-title"
              v-if="item.isTitle"
              :key="item.id"
              :id="'side-'+item.id"
            >{{ (item.label) }}</li>
            <li v-if="!item.isTitle && !item.isLayout" :key="item.id" :id="'side-'+item.id">
              <a
                v-if="hasItems(item)"
                href="javascript:void(0);"
                class="is-parent"
                :class="{'has-arrow': !!(!(item.badge && getBadge(item.badge.text) !== '')), 'has-dropdown': item.badge}"
              >
                <i :class="`bx ${item.icon}`" v-if="item.icon"></i>
                <span>{{ (item.label) }}</span>
                <span
                  :class="`badge badge-pill badge-${item.badge.variant} float-right`"
                  v-if="item.badge && getBadge(item.badge.text) !== ''"
                >{{getBadge(item.badge.text)}}</span>
                <!-- <span
                  :class="`badge badge-pill badge-${item.badge.variant} float-right`"
                  v-if="item.badge"
                >{{ (item.badge.text)}}</span> -->
              </a>

              <router-link :to="item.link" v-if="!hasItems(item)" class="side-nav-link-ref">
                <i :class="`bx ${item.icon}`" v-if="item.icon"></i>
                <span>{{ (item.label) }}</span>
                <span
                  :class="`badge badge-pill badge-${item.badge.variant} float-right`"
                  v-if="item.badge && getBadge(item.badge.text) !== ''"
                >{{getBadge(item.badge.text)}}</span>
              </router-link>

              <ul v-if="hasItems(item)" class="sub-menu" aria-expanded="false">
                <li v-for="(subitem, index) of item.subItems" :key="index">
                  <router-link
                    :to="subitem.link"
                    v-if="!hasItems(subitem)"
                    class="side-nav-link-ref"
                  > <span>{{ (subitem.label) }}</span>
                    <span
                          :class="`badge badge-pill badge-${subitem.badge.variant} float-right`"
                          v-if="subitem.badge && getBadge(subitem.badge.text) !== ''"
                        >{{ getBadge(subitem.badge.text)}}</span>
                  </router-link>
                  <a
                    v-if="hasItems(subitem)"
                    class="side-nav-link-a-ref has-arrow"
                    href="javascript:void(0);"
                  >{{ (subitem.label) }}</a>
                  <ul v-if="hasItems(subitem)" class="sub-menu mm-collapse" aria-expanded="false">
                    <li v-for="(subSubitem, i) of subitem.subItems" :key="100+i">
                      <router-link
                        :to="subSubitem.link"
                        class="side-nav-link-ref"
                      >
                        <span>{{ (subSubitem.label) }}</span>
                      </router-link>

                    </li>
                  </ul>
                </li>
              </ul>
            </li>
          </template>
        </ul>

    </div>
     <!-- <NavBar/> -->
  </div>
  <!-- Sidebar -->
</template>

<style scoped>
.mgauto {
  margin: 0 auto;
}

.metismenu {
  text-transform: capitalize;
}

#sidebar-menu ul li a {
  font-size: 14px !important;
}

#sidebar-menu ul li ul.sub-menu li a {
  font-size: 14px !important;
}

.side-nav-link-ref.active i {
  color: #ffffff !important;
  padding-bottom: 0 !important;
}

.side-nav-link-ref.router-link-active,
.side-nav-link-ref.router-link-active:hover {
  background: #556ee6 !important;
  color: #fff !important;
}

.side-nav-link-ref i:hover {
  background: #556ee6;
  opacity: .1;
}

#sidebar-menu ul li a:hover {
  color: #545a6d;
  background: #556ee610;
}

.simplebar-content #sidebar-menu {
  padding-bottom: 0;
}
</style>